Index: LMDZ4/trunk/libf/phylmd/iophy.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/iophy.F90	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/iophy.F90	(revision 776)
@@ -12,11 +12,10 @@
     MODULE PROCEDURE histwrite2d_phy,histwrite3d_phy
   END INTERFACE 
-  
-  REAL,private,allocatable,save,dimension(:,:) :: buffer_omp
 
 contains
 
   subroutine init_iophy(lat,lon)
-  use dimphy
+  USE dimphy
+  USE mod_phys_lmdz_para
   use ioipsl
   implicit none
@@ -38,34 +37,33 @@
     allocate(io_lon(iim))
     io_lon(:)=lon(:)
-    allocate(tmp_tab2d(iim,jjphy_nb))
-    allocate(tmp_tab3d(iim,jjphy_nb,klev))
-    allocate(ndex2d(iim*jjphy_nb))
-    allocate(ndex3d(iim*jjphy_nb*klev))
+    allocate(tmp_tab2d(iim,jj_nb))
+    allocate(tmp_tab3d(iim,jj_nb,klev))
+    allocate(ndex2d(iim*jj_nb))
+    allocate(ndex3d(iim*jj_nb*klev))
     ndex2d(:)=0
     ndex3d(:)=0
-    allocate(buffer_omp(klon_mpi,klev))
     
     ddid=(/ 1,2 /)
     dsg=(/ iim, jjm+1 /)
-    dsl=(/ iim, jjphy_nb /)
-    dpf=(/ 1,jjphy_begin /)
-    dpl=(/ iim, jjphy_end /)
-    dhs=(/ iiphy_begin-1,0 /)
-    if (phy_rank==phy_size-1) then
+    dsl=(/ iim, jj_nb /)
+    dpf=(/ 1,jj_begin /)
+    dpl=(/ iim, jj_end /)
+    dhs=(/ ii_begin-1,0 /)
+    if (mpi_rank==mpi_size-1) then
       dhe=(/0,0/)
     else
-      dhe=(/ iim-iiphy_end,0 /)  
+      dhe=(/ iim-ii_end,0 /)  
     endif
     
-    call flio_dom_set(phy_size,phy_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe, &
+    call flio_dom_set(mpi_size,mpi_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe, &
                       'APPLE',phys_domain_id)
 
 !$OMP END MASTER
-!$OMP FLUSH(buffer_omp)
       
   end subroutine init_iophy
   
   subroutine histbeg_phy(name,itau0,zjulian,dtime,nhori,nid_day)
-  use dimphy
+  USE dimphy
+  USE mod_phys_lmdz_para
   use ioipsl
   use write_field
@@ -81,10 +79,10 @@
 
 !$OMP MASTER    
-    if (monocpu) then
-      call histbeg(name,iim,io_lon, jjphy_nb,io_lat(jjphy_begin:jjphy_end), &
-                   1,iim,1,jjphy_nb,itau0, zjulian, dtime, nhori, nid_day)
+    if (is_sequential) then
+      call histbeg(name,iim,io_lon, jj_nb,io_lat(jj_begin:jj_end), &
+                   1,iim,1,jj_nb,itau0, zjulian, dtime, nhori, nid_day)
     else
-      call histbeg(name,iim,io_lon, jjphy_nb,io_lat(jjphy_begin:jjphy_end), &
-                   1,iim,1,jjphy_nb,itau0, zjulian, dtime, nhori, nid_day,phys_domain_id)
+      call histbeg(name,iim,io_lon, jj_nb,io_lat(jj_begin:jj_end), &
+                   1,iim,1,jj_nb,itau0, zjulian, dtime, nhori, nid_day,phys_domain_id)
     endif
 !$OMP END MASTER
@@ -93,6 +91,7 @@
   
   subroutine histwrite2d_phy(nid,name,itau,field)
-  use dimphy
-  use ioipsl
+  USE dimphy
+  USE mod_phys_lmdz_para
+  USE ioipsl
   implicit none
   include 'dimensions90.h'
@@ -102,14 +101,18 @@
     integer, intent(in) :: itau
     real,dimension(klon),intent(in) :: field
-
-    CALL GatherField_omp(field,buffer_omp,1)    
+    
+    REAL,dimension(klon_mpi) :: buffer_omp
+    
+    CALL Gather_omp(field,buffer_omp)    
 !$OMP MASTER
-    CALL phy2dyn(buffer_omp,tmp_tab2d,1)
-    CALL histwrite(nid,name,itau,tmp_tab2d,iim*jjphy_nb,ndex2d)
+    CALL grid1Dto2D_mpi(buffer_omp,tmp_tab2d)
+    CALL histwrite(nid,name,itau,tmp_tab2d,iim*jj_nb,ndex2d)
 !$OMP END MASTER    
   end subroutine histwrite2d_phy
   
   subroutine histwrite3d_phy(nid,name,itau,field)
-  use dimphy
+  USE dimphy
+  USE mod_phys_lmdz_para
+
   use ioipsl
   implicit none
@@ -120,58 +123,60 @@
     integer, intent(in) :: itau
     real,dimension(klon,klev),intent(in) :: field
+
+    REAL,dimension(klon_mpi,klev) :: buffer_omp
     
-    CALL GatherField_omp(field,buffer_omp,klev)
+    CALL Gather_omp(field,buffer_omp)
 !$OMP MASTER
-    CALL phy2dyn(buffer_omp,tmp_tab3d,klev)
-    CALL histwrite(nid,name,itau,tmp_tab3d,iim*jjphy_nb*klev,ndex3d)
+    CALL grid1Dto2D_mpi(buffer_omp,tmp_tab3d)
+    CALL histwrite(nid,name,itau,tmp_tab3d,iim*jj_nb*klev,ndex3d)
 !$OMP END MASTER    
   end subroutine histwrite3d_phy
   
   
-  subroutine phy2dyn(field_phy,field_dyn,nlev)
-  use dimphy
-  implicit none
-  include 'dimensions90.h'
-  
-    real,dimension(klon_mpi,nlev),intent(in) :: field_phy
-    real,dimension(iim,jjphy_nb,nlev),intent(out) :: field_dyn
-    integer,intent(in) :: nlev
-    
-    integer :: next
-    integer :: j,l
-    
-      do l=1,nlev
-        	
-	if (jjphy_begin==jjphy_end) then
-	  field_dyn(:,1,l)=0.
-	  field_dyn(iiphy_begin:iiphy_end,1,l)=field_phy(1:klon_mpi,l)
-	else
-	
-	 if (jjphy_begin==1) then
-	    field_dyn(:,1,l)=field_phy(1,l)
-	    next=2
-	 else
-	   field_dyn(:,1,l)=0.
-	   next=iim-iiphy_begin+2
-	   field_dyn(iiphy_begin:iim,1,l)=field_phy(1:next-1,l)   
-	 endif
-	
-	  do j=2,jjphy_nb-1
-	    field_dyn(:,j,l)=field_phy(next:next+iim-1,l)
-	    next=next+iim
-	  enddo
-	  
-	  if (jjphy_end==jjm+1) then
-             field_dyn(:,jjphy_nb,l)=field_phy(klon_mpi,l)
-	  else
-	   field_dyn(:,jjphy_nb,l)=0.
-	   field_dyn(1:iiphy_end,jjphy_nb,l)=field_phy(next:next+iiphy_end-1,l)   
-	  endif
-	  
-	endif
-     
-     enddo
-	 
-    end subroutine phy2dyn	    
+!  subroutine phy2dyn(field_phy,field_dyn,nlev)
+!  USE dimphy_old
+!  implicit none
+!  include 'dimensions90.h'
+!  
+!    real,dimension(klon_mpi,nlev),intent(in) :: field_phy
+!    real,dimension(iim,jjphy_nb,nlev),intent(out) :: field_dyn
+!    integer,intent(in) :: nlev
+!    
+!    integer :: next
+!    integer :: j,l
+!    
+!      do l=1,nlev
+!        	
+!	if (jjphy_begin==jjphy_end) then
+!	  field_dyn(:,1,l)=0.
+!	  field_dyn(iiphy_begin:iiphy_end,1,l)=field_phy(1:klon_mpi,l)
+!	else
+!	
+!	 if (jjphy_begin==1) then
+!	    field_dyn(:,1,l)=field_phy(1,l)
+!	    next=2
+!	 else
+!	   field_dyn(:,1,l)=0.
+!	   next=iim-iiphy_begin+2
+!	   field_dyn(iiphy_begin:iim,1,l)=field_phy(1:next-1,l)   
+!	 endif
+!	
+!	  do j=2,jjphy_nb-1
+!	    field_dyn(:,j,l)=field_phy(next:next+iim-1,l)
+!	    next=next+iim
+!	  enddo
+!	  
+!	  if (jjphy_end==jjm+1) then
+!             field_dyn(:,jjphy_nb,l)=field_phy(klon_mpi,l)
+!	  else
+!	   field_dyn(:,jjphy_nb,l)=0.
+!	   field_dyn(1:iiphy_end,jjphy_nb,l)=field_phy(next:next+iiphy_end-1,l)   
+!	  endif
+!	  
+!	endif
+!     
+!     enddo
+!	 
+!    end subroutine phy2dyn	    
   
 	  
Index: LMDZ4/trunk/libf/phylmd/isccp_cloud_types.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/isccp_cloud_types.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/isccp_cloud_types.F	(revision 776)
@@ -32,5 +32,4 @@
      &)
 	
-!$Id$
 
 ! Copyright Steve Klein and Mark Webb 2002 - all rights reserved.
Index: LMDZ4/trunk/libf/phylmd/moy_undefSTD.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/moy_undefSTD.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/moy_undefSTD.F	(revision 776)
@@ -1,2 +1,5 @@
+!
+! $Header$
+!
       SUBROUTINE moy_undefSTD(nlevSTD,itap,
      $           dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
Index: LMDZ4/trunk/libf/phylmd/moyglo_aire.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/moyglo_aire.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/moyglo_aire.F	(revision 776)
@@ -1,2 +1,5 @@
+!
+! $Header$
+!
       SUBROUTINE moyglo_pondaire(nhori, champ, aire, 
      .            ok_msk, msk, moyglo)
Index: LMDZ4/trunk/libf/phylmd/oasis.psmile
===================================================================
--- LMDZ4/trunk/libf/phylmd/oasis.psmile	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/oasis.psmile	(revision 776)
@@ -94,5 +94,5 @@
 ! Here we go: psmile initialisation
 !
-    IF (monocpu) THEN
+    IF (is_sequential) THEN
       call prism_init_comp_proto (comp_id, clmodnam, ierror)
 
@@ -116,8 +116,8 @@
 !ym   ig_paral(3) = im * jm
    ig_paral(1) = 1    ! apple partition for //
-   ig_paral(2) = (jjphy_begin-1)*im+iiphy_begin-1
-   ig_paral(3) = (jjphy_end*im+iiphy_end)-(jjphy_begin*im+iiphy_begin)+1
-   if (phy_rank==phy_size-1) ig_paral(3)=ig_paral(3)+im-1
-   print *,phy_rank,'ig_paral--->',ig_paral(2),ig_paral(3)
+   ig_paral(2) = (jj_begin-1)*im+ii_begin-1
+   ig_paral(3) = (jj_end*im+ii_end)-(jj_begin*im+ii_begin)+1
+   if (mpi_rank==mpi_size-1) ig_paral(3)=ig_paral(3)+im-1
+   print *,mpi_rank,'ig_paral--->',ig_paral(2),ig_paral(3)
    
    ierror=PRISM_Ok
@@ -222,5 +222,6 @@
    use mod_prism_proto
    use mod_prism_get_proto
-   use dimphy
+   USE dimphy
+   USE mod_phys_lmdz_para
    IMPLICIT none
 
@@ -250,9 +251,9 @@
    CALL flush (nuout)
 
-   istart=iiphy_begin
-   if (phy_rank==phy_size-1) then
-    iend=(jjphy_end-jjphy_begin)*im+im
+   istart=ii_begin
+   if (is_south_pole) then
+    iend=(jj_end-jj_begin)*im+im
    else
-    iend=(jjphy_end-jjphy_begin)*im+iiphy_end
+    iend=(jj_end-jj_begin)*im+ii_end
    endif
    
@@ -313,5 +314,6 @@
    use mod_prism_proto
    use mod_prism_put_proto
-   use dimphy
+   USE dimphy
+   USE mod_phys_lmdz_para
    use write_field_phy
    IMPLICIT NONE
@@ -345,9 +347,9 @@
       WRITE(nuout,*)
 
-   istart=iiphy_begin
-   if (phy_rank==phy_size-1) then
-    iend=(jjphy_end-jjphy_begin)*im+im
+   istart=ii_begin
+   if (is_south_pole) then
+    iend=(jj_end-jj_begin)*im+im
    else
-    iend=(jjphy_end-jjphy_begin)*im+iiphy_end
+    iend=(jj_end-jj_begin)*im+ii_end
    endif
 
@@ -355,6 +357,6 @@
      wstart=istart
      wend=iend
-     IF (phy_rank==0) wstart=istart+im-1
-     IF (phy_rank==phy_size-1) wend=iend-im+1
+     IF (is_north_pole) wstart=istart+im-1
+     IF (is_south_pole) wend=iend-im+1
    
      CALL writeField_phy("fsolice",fsolice(wstart:wend),1)
@@ -533,5 +535,5 @@
 
    if (last) then
-     IF (monocpu) THEN 
+     IF (is_sequential) THEN 
        call prism_terminate_proto(ierror)
          IF (ierror .ne. PRISM_Ok) THEN
Index: LMDZ4/trunk/libf/phylmd/orografi.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/orografi.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/orografi.F	(revision 776)
@@ -1481,5 +1481,5 @@
 C*       0.2   LOCAL ARRAYS
 C              ------------
-      logical lifthigh, ll1
+      logical lifthigh
 cym      integer klevm1, jl, ilevh, jk
       integer  jl, ilevh, jk
@@ -1711,4 +1711,6 @@
       SUBROUTINE SUGWD(NLON,NLEV,paprs,pplay)
       USE dimphy
+      USE mod_phys_lmdz_para
+      USE mod_grid_phy_lmdz
 c      USE parallel
 C
@@ -1764,8 +1766,6 @@
       REAL pplay(nlon,nlev)
       real zpr,zstra,zsigt,zpm1r
-      REAL,SAVE,ALLOCATABLE :: pplay_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: paprs_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: pplay_glo(:,:)
-      REAL,SAVE,ALLOCATABLE :: paprs_glo(:,:)
+      REAL :: pplay_glo(klon_glo,nlev)
+      REAL :: paprs_glo(klon_glo,nlev+1)
 
 C
@@ -1784,27 +1784,17 @@
 cold  ZSIGT=0.85
 C
-c$OMP MASTER
-      ALLOCATE(pplay_mpi(klon_mpi,nlev))
-      ALLOCATE(paprs_mpi(klon_mpi,nlev+1))
-      ALLOCATE(pplay_glo(klon2,nlev))
-      ALLOCATE(paprs_glo(klon2,nlev+1))
-c$OMP END MASTER
-c$OMP BARRIER
-
-      CALL GatherField_omp(pplay,pplay_mpi,nlev)      
-      CALL GatherField_omp(paprs,paprs_mpi,nlev+1)
-
-c$OMP MASTER      
-      CALL  AllGatherField(pplay_mpi,pplay_glo,nlev)
-      CALL  AllGatherField(paprs_mpi,paprs_glo,nlev+1)
-c$OMP END MASTER
-c$OMP BARRIER
       
+      CALL gather(pplay,pplay_glo)
+      CALL bcast(pplay_glo)
+      CALL gather(paprs,paprs_glo)
+      CALL bcast(paprs_glo)
+      
+            
       DO 110 JK=1,NLEV
-      ZPM1R=pplay_glo(klon2/2,jk)/paprs_glo(klon2/2,1) 
+      ZPM1R=pplay_glo(klon_glo/2,jk)/paprs_glo(klon_glo/2,1) 
       IF(ZPM1R.GE.ZSIGT)THEN
          nktopg=JK
       ENDIF
-      ZPM1R=pplay_glo(klon2/2,jk)/paprs_glo(klon2/2,1) 
+      ZPM1R=pplay_glo(klon_glo/2,jk)/paprs_glo(klon_glo/2,1) 
       IF(ZPM1R.GE.ZSTRA)THEN
          NSTRA=JK
@@ -1812,12 +1802,4 @@
   110 CONTINUE
 
-c$OMP BARRIER
-c$OMP MASTER
-      DEALLOCATE(pplay_mpi)
-      DEALLOCATE(paprs_mpi)
-      DEALLOCATE(pplay_glo)
-      DEALLOCATE(paprs_glo)
-c$OMP END MASTER
-c$OMP BARRIER
 
 c
